SystemOrganization addCategory: #'CS528-UT3Base'!

TestCase subclass: #UT3BoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BoardTest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/5/2013 00:18'!
test1TakeTurnsEnforcement

	| board1  |
	board1 := UT3Board new initialize.
	board1 player: 1 moveRow: 5 moveCol: 5.
	board1 player: 2 moveRow: 4 moveCol: 4.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 5 moveCol: 6.
	board1 player: 1 moveRow: 5 moveCol: 2.
	board1 player: 2 moveRow: 2 moveCol: 8.
	self assert: (board1 ifplayer: 2 moveRow: 2 moveCol: 8) = true.
	self assert: (board1 ifplayer: 1 moveRow: 5 moveCol: 2) = true.

! !

!UT3BoardTest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/5/2013 00:19'!
test2PrintOn

	| board1  |
	board1 := UT3Board new initialize.
	board1 player: 1 moveRow: 1 moveCol: 1.
	board1 player: 2 moveRow: 4 moveCol: 4.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 5 moveCol: 6.
	board1 player: 1 moveRow: 5 moveCol: 2.
	board1 player: 2 moveRow: 2 moveCol: 8.
	Transcript open; show: board1.

! !

!UT3BoardTest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/5/2013 00:21'!
test3BoardToPlayEnforcement

	| board1  |
	board1 := UT3Board new initialize.
	board1 player: 1 moveRow: 8 moveCol: 8.
	board1 player: 2 moveRow: 5 moveCol: 5.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 8 moveCol: 5.
	board1 player: 1 moveRow: 6 moveCol: 4.
	board1 player: 2 moveRow: 8 moveCol: 2.
	board1 player: 1 moveRow: 4 moveCol: 5.
	board1 player: 2 moveRow: 2 moveCol: 5.
	board1 player: 1 moveRow: 6 moveCol: 6.
	board1 player: 2 moveRow: 7 moveCol: 7.
	self assert: (board1 ifplayer: 2 moveRow: 7 moveCol: 7) = true.
	self assert: (board1 ifplayer: 1 moveRow: 6 moveCol: 6) = true.

! !

Object subclass: #UT3Board
	instanceVariableNames: 'boardMatrix boardGlobalMatrix turnOfPlayer nextBoardToPlay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables

Here are a few quick reason about why I code them that way and 

what are those magic numbers stand for.

First, the board(boardMatrix in the code) is a 9 * 9 matrix they actually don't need to be nested(although they could) because we could access it really convenient by rows and columns and we could submatrix whenever we want. 
(here is a handy list of matrix functions http://magaloma.seasidehosting.st/Collections-Unordered)

Each cell in the board, say 1 out of 81, has three status: 

0: not played yet. 
1: player 1 marked. 
2: player 2 taken. 

That boardGlobalMatrix is 3 * 3 and design to mark the winning status of the small board, 
it changes and only changes when one (of the two players) win a subarea.   
It is a global marker with global winning status overview... so is named with 'global' in it. !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:24'!
checkWinningWithCol: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithSet: ((subMatrix atColumn: 1) asSet)).
	ret2 := (self checkWinningWithSet: ((subMatrix atColumn: 2) asSet)).
	ret3 := (self checkWinningWithSet: ((subMatrix atColumn: 3) asSet)).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:24'!
checkWinningWithDiagonal: subMatrix

	| ret1 ret2  |
	ret1 := (self checkWinningWithSet: ((subMatrix diagonal) asSet)).
	ret2 := (self checkWinningWithSet: ( Set newFrom: { (subMatrix at: 1 at: 3). (subMatrix at: 2 at: 2). (subMatrix at: 3 at: 1)}  )).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[^0]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:24'!
checkWinningWithRow: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithSet: ((subMatrix atRow: 1) asSet)).
	ret2 := (self checkWinningWithSet: ((subMatrix atRow: 2) asSet)).
	ret3 := (self checkWinningWithSet: ((subMatrix atRow: 3) asSet)).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:32'!
checkWinningWithSet: aSet

	|  |
	(aSet size = 1)
	ifTrue:["judge"
		(aSet includes: 1)
		ifTrue:[ ^1 ]
		ifFalse:[
			(aSet includes: 2)
				ifTrue:[ ^2 ]
				ifFalse:[ ^0 ].
			]
		]
	ifFalse:[^0]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:25'!
checkWinningWithSubMatrix: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithRow: subMatrix).
	ret2 := (self checkWinningWithCol: subMatrix).
	ret3 := (self checkWinningWithDiagonal: subMatrix).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Play Game' stamp: 'Oliver 7/2/2013 00:36'!
ifplayer: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	
	"aPlayer is 1 of int for playerA and 2 of int for playerB"
	|  |
	( (aPlayer) == (boardMatrix at: aMoveRow at: aMoveCol ))
	ifTrue:[ ^true ]
	ifFalse:[ ^false ].
	
! !

!UT3Board methodsFor: 'initialize-release' stamp: 'Oliver 7/5/2013 00:02'!
initialize 

	|  |
	"Main 9 * 9 game board"
	boardMatrix := Matrix new: 9.
	boardMatrix atAllPut: 0.
	"Global view of sub board winning status with 3 * 3 Matrix"
	boardGlobalMatrix := Matrix new: 3.
	boardGlobalMatrix atAllPut: 0.
	"playerA plays First!!!!"
	turnOfPlayer := 1.
	"Each cell in the board, say 1 out of 81, has three status: 
	0: not played yet. 
	1: player 1 marked. 
	2: player 2 taken. "! !

!UT3Board methodsFor: 'Play Game' stamp: 'Oliver 7/5/2013 00:43'!
player: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	
	| tempRow tempCol subMatrix ret1 tempBoardToPlay |
	(turnOfPlayer ~= aPlayer)
	ifTrue:[ self error: 'It is the other players turn!!!!'  ]
	ifFalse:["go ahead and play the move as below"].
	
	"aPlayer is 1 of int for playerA and 2 of int for playerB"
	( (0) == (boardMatrix at: aMoveRow at: aMoveCol ))
	ifTrue:[ 
		(aPlayer = 2)
		ifTrue:[ "check if the board to play is right"
			tempRow := (aMoveRow - (aMoveRow % 3)) / 3  + 1.
			tempCol := (aMoveCol - (aMoveCol % 3)) / 3  + 1.
			tempBoardToPlay := #(tempRow tempCol).
			( nextBoardToPlay = tempBoardToPlay )
			ifTrue:["the right board"
				boardMatrix at: aMoveRow at: aMoveCol put: aPlayer.  
				]
			ifFalse:[ self error: 'Not the right board to play!!'  ]
		]
		ifFalse:[
			boardMatrix at: aMoveRow at: aMoveCol put: aPlayer.
		]
	]
	ifFalse:[ 
		self error: 'Player could only be 1 or 2 and one can only play in an empty slot!!'   
	].
	"switch next turn for the other player"
	turnOfPlayer := 3 - turnOfPlayer.
	"update the board to play nextBoardToPlay"
	tempRow := (aMoveRow - (aMoveRow % 3)) / 3  + 1.
	tempCol := (aMoveCol - (aMoveCol % 3)) / 3  + 1.
	nextBoardToPlay := #(tempRow tempCol).
	
	"check if anybody wins any subBoard or the game"
	tempRow := (aMoveRow - (aMoveRow % 3))  + 1.
	tempCol := (aMoveCol - (aMoveCol % 3))  + 1.
	subMatrix := boardMatrix atRows: tempRow to: (tempRow+2) columns: tempCol to: (tempCol+2).
	
	ret1 := self checkWinningWithSubMatrix: subMatrix.
	ret1 > 0
	ifTrue:[
		tempRow := (tempRow -1)/3 + 1.
		tempCol := (tempCol -1)/3 + 1.
		boardGlobalMatrix at: tempRow at: tempCol put: ret1
		]
	ifFalse:[	 "nobody wins anything in this move, so nothing to do here ATM"	].
			
	"check if anybody wins the game"
	
	! !

!UT3Board methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/3/2013 10:19'!
printOn: aStream
	" prints the gameboard on a stream"
	| i elementsPerRow |
	i := 0.
	elementsPerRow := 9.
	boardMatrix do: [ :ele | 
		"aStream nextPut: $|."
		ele = 0 ifTrue: [ aStream nextPutAll: '    |'].
		ele = 1 ifTrue: [ aStream nextPutAll: ' X |'].
		ele = 2 ifTrue: [ aStream nextPutAll: ' O |'].
		i := i + 1.
		(i // elementsPerRow) > 0 ifTrue: [ 
			aStream cr.
			i := 0. ]
	].! !

Object subclass: #UT3System
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!
